lambda = 0.3;

L = 3;
cvx_begin quiet
cvx_precision('best');

variables t w1 w2;
variable rho(L,L) toeplitz semidefinite;
variable tmat(L,L) semidefinite;

rho(1,1) == 1/L;
rho(1,2) == w1/L;
rho(1,3) == w2/L;

for j=2:L
    tmat(j,j) == 1;
    for k=j+1:L
        tmat(j,k) == 0;
    end
end

tmat(1,1) == t;
tmat(1,2) == w1 - 1.0/2.0/lambda;
tmat(1,3) == w2/sqrt(2);

minimize(t);
cvx_end

fprintf('t = %f, w1 = %f, 1-lambda/2 = %f\n',t, w1, 1-lambda/2);












L = 5;

cvx_begin quiet

cvx_precision('best');
variables t w1 w2 w3 w4;
variable rho(L,L) toeplitz semidefinite;
variable tmat(L,L) semidefinite;

rho(1,1) == 1/L;
rho(1,2) == w1/L;
rho(1,3) == w2/L;
rho(1,4) == w3/L;
rho(1,5) == w4/L;




for j=2:L
    tmat(j,j) == 1;
    for k=j+1:L
        tmat(j,k) == 0;
    end
end


tmat(1,1) == t;
tmat(1,2) == w1 - 1.0/2.0/lambda;
tmat(1,3) == w2/sqrt(2);
tmat(1,4) == w3/sqrt(3);
tmat(1,5) == w4/sqrt(4);



minimize(t);
cvx_end

fprintf('t = %f, w1 = %f, 1-lambda/2 = %f\n',t, w1, 1-lambda/2);



L = 10;

cvx_begin quiet

cvx_precision('best');
variables t w1 w2 w3 w4 w5 w6 w7 w8 w9;
variable rho(L,L) toeplitz semidefinite;
variable tmat(L,L) semidefinite;

rho(1,1) == 1/L;
rho(1,2) == w1/L;
rho(1,3) == w2/L;
rho(1,4) == w3/L;
rho(1,5) == w4/L;
rho(1,6) == w5/L;
rho(1,7) == w6/L;
rho(1,8) == w7/L;
rho(1,9) == w8/L;
rho(1,10) == w9/L;



for j=2:L
    tmat(j,j) == 1;
    for k=j+1:L
        tmat(j,k) == 0;
    end
end


tmat(1,1) == t;
tmat(1,2) == w1 - 1.0/2.0/lambda;
tmat(1,3) == w2/sqrt(2);
tmat(1,4) == w3/sqrt(3);
tmat(1,5) == w4/sqrt(4);
tmat(1,6) == w5/sqrt(5);
tmat(1,7) == w6/sqrt(6);
tmat(1,8) == w7/sqrt(7);
tmat(1,9) == w8/sqrt(8);
tmat(1,10) == w9/sqrt(9);


minimize(t);
cvx_end

fprintf('t = %f, w1 = %f, 1-lambda/2 = %f\n',t, w1, 1-lambda/2);


L = 15;


cvx_begin quiet

cvx_precision('best');

variables t w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14;
variable rho(L,L) toeplitz semidefinite;
variable tmat(L,L) semidefinite;

rho(1,1) == 1/L;
rho(1,2) == w1/L;
rho(1,3) == w2/L;
rho(1,4) == w3/L;
rho(1,5) == w4/L;
rho(1,6) == w5/L;
rho(1,7) == w6/L;
rho(1,8) == w7/L;
rho(1,9) == w8/L;
rho(1,10) == w9/L;
rho(1,11) == w10/L;
rho(1,12) == w11/L;
rho(1,13) == w12/L;
rho(1,14) == w13/L;
rho(1,15) == w14/L;



for j=2:L
    tmat(j,j) == 1;
    for k=j+1:L
        tmat(j,k) == 0;
    end
end


tmat(1,1) == t;
tmat(1,2) == w1 - 1.0/2.0/lambda;
tmat(1,3) == w2/sqrt(2);
tmat(1,4) == w3/sqrt(3);
tmat(1,5) == w4/sqrt(4);
tmat(1,6) == w5/sqrt(5);
tmat(1,7) == w6/sqrt(6);
tmat(1,8) == w7/sqrt(7);
tmat(1,9) == w8/sqrt(8);
tmat(1,10) == w9/sqrt(9);
tmat(1,11) == w10/sqrt(10);
tmat(1,12) == w11/sqrt(11);
tmat(1,13) == w12/sqrt(12);
tmat(1,14) == w13/sqrt(13);
tmat(1,15) == w14/sqrt(14);


minimize(t);
cvx_end

fprintf('t = %f, w1 = %f, 1-lambda/2 = %f\n',t, w1, 1-lambda/2);

L = 20;


cvx_begin quiet

cvx_precision('best');

variables t w1 w2 w3 w4 w5 w6 w7 w8 w9 w10 w11 w12 w13 w14 w15 w16 w17 w18 w19;
variable rho(L,L) toeplitz semidefinite;
variable tmat(L,L) semidefinite;

rho(1,1) == 1/L;
rho(1,2) == w1/L;
rho(1,3) == w2/L;
rho(1,4) == w3/L;
rho(1,5) == w4/L;
rho(1,6) == w5/L;
rho(1,7) == w6/L;
rho(1,8) == w7/L;
rho(1,9) == w8/L;
rho(1,10) == w9/L;
rho(1,11) == w10/L;
rho(1,12) == w11/L;
rho(1,13) == w12/L;
rho(1,14) == w13/L;
rho(1,15) == w14/L;
rho(1,16) == w15/L;
rho(1,17) == w16/L;
rho(1,18) == w17/L;
rho(1,19) == w18/L;
rho(1,20) == w19/L;



for j=2:L
    tmat(j,j) == 1;
    for k=j+1:L
        tmat(j,k) == 0;
    end
end


tmat(1,1) == t;
tmat(1,2) == w1 - 1.0/2.0/lambda;
tmat(1,3) == w2/sqrt(2);
tmat(1,4) == w3/sqrt(3);
tmat(1,5) == w4/sqrt(4);
tmat(1,6) == w5/sqrt(5);
tmat(1,7) == w6/sqrt(6);
tmat(1,8) == w7/sqrt(7);
tmat(1,9) == w8/sqrt(8);
tmat(1,10) == w9/sqrt(9);
tmat(1,11) == w10/sqrt(10);
tmat(1,12) == w11/sqrt(11);
tmat(1,13) == w12/sqrt(12);
tmat(1,14) == w13/sqrt(13);
tmat(1,15) == w14/sqrt(14);
tmat(1,16) == w15/sqrt(15);
tmat(1,17) == w16/sqrt(16);
tmat(1,18) == w17/sqrt(17);
tmat(1,19) == w18/sqrt(18);
tmat(1,20) == w19/sqrt(19);


minimize(t);
cvx_end

fprintf('t = %f, w1 = %f, 1-lambda/2 = %f\n',t, w1, 1-lambda/2);
